--[[
    Description: Insert Pitch Bend
    Version: 1.0.1
    Author: zaibuyidao (再補一刀)
    Website: https://www.soundengine.cn/user/%E5%86%8D%E8%A3%9C%E4%B8%80%E5%88%80
    Donation: http://www.paypal.me/zaibuyidao
--]]

local take = reaper.MIDIEditor_GetTake(reaper.MIDIEditor_GetActive())
local pos = reaper.GetCursorPositionEx(0)
local ppq = reaper.MIDI_GetPPQPosFromProjTime(take, pos)
local retval, userinput = reaper.GetUserInputs('Insert Pitch Bend', 1, 'Value', '0')
if not retval then return reaper.SN_FocusMIDIEditor() end

local value = math.floor(userinput)
if value < -8192 or value > 8191 then
    return
        reaper.MB("Please enter a value from -8192 through 8191", "Error", 0),
        reaper.SN_FocusMIDIEditor()
end

value = value + 8192
local lsb = value & 0x7f
local msb = value >> 7 & 0x7f
reaper.MIDI_InsertCC(take, false, false, ppq, 224, 0, lsb, msb)
reaper.UpdateArrange()
reaper.SN_FocusMIDIEditor()
